#include <xc.h>

#include "PIC18F4550_config.h"
#include "delay.h"
#include "delay.c"
#include "I2C.h"
#include<PCF8574.h>
#include<PCF8574.c>
#include "LCD_44780_I2C.h"
#include "LCD_44780_I2C.c"
/*#include "LCD_44780.h"
#include "LCD_44780.c" */
#define LCD_DEFAULT

//*************************************
//     Costanti del programma
//*************************************
#define FRASE_1 "Hello World 1"


//*************************************
//     Prototipo di funzione
//*************************************
void board_initialization (void);


//*************************************
//     Programma principale
//*************************************
int main (void){

    board_initialization ();

    // Inizializzo il display LCD con quarzo a 20MHz
    LCD_initialize (20);

    LCD_backlight (LCD_TURN_ON_LED);

    LCD_write_message (FRASE_1);

    LCD_goto_line (2);

    LCD_write_message ("Hello World 2");
    
    // Ciclo infinito
    while (1) {

    }
}


//*************************************
//     Implementazione della funzione
//*************************************
void board_initialization (void) {
        // Imposto PORTA tutti ingressi
    LATA = 0x00;
    TRISA = 0xFF;

    // Imposto PORTB tutti ingressi
    LATB = 0x00;
    TRISB = 0xFF;

    // Imposto PORTC tutti ingressi, RC1 come output
    LATC = 0x00;
    TRISC = 0b11111101;

    // Imposto PORTD tutte uscite, RD0 come ingresso
    LATD = 0x00;
    TRISD = 0b00000001;

    // Imposto PORTE tutti ingressi
    LATE = 0x00;
    TRISE = 0xFF;
}
